from random import randint, choice


def big_fuckin_mac() -> str:
    hexchars = "ABCDEF0123456789"
    return f'''{'-'.join([f"{choice(hexchars)}{choice(hexchars)}" for _ in range(6)])}'''


class TagPoint:

    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y

    def __str__(self):
        return f"{self.x},{self.y}"


class Random:

    def __init__(self):
        self.seed_1 = randint(1, 2**31 - 1)
        self.seed_2 = randint(1, 2**31 - 1)
        self.seed_3 = randint(1, 2**31 - 1)

    def encode(self, packet):
        packet.encode_int(self.seed_1)
        packet.encode_int(self.seed_2)
        packet.encode_int(self.seed_3)


def find(predicate, seq):
    for element in seq:
        if predicate(element):
            return element
    return None


def get(iterable, **attrs):

    def predicate(elem):
        for attr, val in attrs.items():
            nested = attr.split("__")
            obj = elem
            for attribute in nested:
                obj = getattr(obj, attribute)

            if obj != val:
                return False
        return True

    return find(predicate, iterable)


def first_or_default(list_, f):
    return next((val for val in list_ if f(val)), None)


def to_string(bytes_):
    return " ".join([
        bytes_.hex()[i:i + 2].upper() for i in range(0, len(bytes_.hex()), 2)
    ])
